#!/usr/bin/perl

#A little utility to assist with 
#updating the cfg files in the cfg directory

my $dir = "@ARGV";
$#ARGV = -1;

if ($dir eq "") {
	$dir = `pwd`;
	chomp($dir);
	if (index("$0", "rebuild") > -1) {
		#Too strong..
		system("rm -f CFG/*");
	}
} elsif (index("$0", "rebuild") > -1) {
	my $cfg = &basename("$dir");
	if (-e "CFG/$cfg.cfg") {
		print "Deleting CFG/$cfg.cfg\n";
		unlink "CFG/$cfg.cfg";
	}
}
##my @files = `find $dir -type f -print`;
my @files = &list_files("$dir");

my ($cfg, $f, @subs, $s, @opts, $pt);

foreach $f (@files) {
	if ($f ne "") {
		chomp($f);
		if ($f =~ /build.pl$/) {
			next;
		}
		$cfg = &dirname("$f");
		$cfg = &basename("$cfg");
		if ($cfg =~ /^\./ or $cfg =~ /CFG/) {
			#Simply skip README's HOWTO or CFG it self..
			next;
		}
		$cfg = "CFG/$cfg.cfg";
		#Here we should check the file for correct operation
		if (system("perl", "-w", "$f") != 0) {
			print "Aborting $f due to Perl Error\n";
			#next;
			last;
		}
		@subs=`grep ^sub $f`;
		if ($#subs == -1) {
			#Use the file name..
			my $t = &basename("$f");
			if ($t ne "") {
				push(@subs, "FAKE $t");
			}
		}
		#Now for the options
		open (CFG, ">> $cfg");
		foreach $s (@subs) {
			if ($s =~ /^sub\s+(.+?)[\s{]+/) {
				print CFG "AddHandler module $1 $f\n";
			}
			$s = (split(/ +/, $s))[1];
			#@opts=`grep \"^\#\" $f | grep \" $s \"`;
			@opts=`grep \"^\#\" $f`;
			foreach $pt (@opts) {
				if ($pt !~ /^\#$s / and $pt !~ / $s\(/ and $pt !~ / $s / and $pt !~ / $s$/ and $pt !~ /\S+\s*\:\s*$s\s*\(*/) {
					if ($pt !~ /^\#\&$s / and $pt !~ / \&$s\(/ and $pt !~ / \&$s / and $pt !~ / \&$s$/ and $pt !~ /\S+\s*\:\s*\&$s\s*\(*/) {
						#We don't have the name of this subroutine in it..
						next;
					}
				}
				$pt =~ s/^\#//g;
				$pt =~ s/^\s+//g;
				#Remove any leading subroutine name
				#useful for Addif and AddEndIF and co..
				$pt =~ s/^$s//g;
				$pt =~ s/^\s+//g;
				if ($pt =~ /^add/i or $pt =~ /^loadmodule/i) {
					print CFG "$pt";
				}
			}
		}
		#Now add all the AddTest definitions
		close (CFG);
	}
}

#We should call modload.pl
my $topdir = &dirname($0);
system("$topdir/modload.pl");

sub dirname {
	my $dir = shift;
	my @path = split(/\//, $dir);
	pop(@path);
	$dir = join('/', @path);
	return "$dir";
}
sub basename {
	my $dir = shift;
	my @path = split(/\//, $dir);
	$dir = pop(@path);
	return "$dir";
}

sub list_files {
	my (@res);
	my $dir = shift;
	$dir =~ s/\/$//g;
	if ($dir eq "") {
		return;
	}
	if ($dir !~ /^\//) {
		my $cwd =`pwd`;
		chomp($cwd);
		chdir "$dir";
		$dir=`pwd`;
		chomp($dir);
		chdir "$cwd";
	}
	opendir (MYDIR, "$dir");
	my @l = readdir(MYDIR);
	foreach $t (@l) {
		if ($t =~ /^\./) {
			next;
		} elsif (-d "$dir/$t") {
			push (@res, &list_files("$dir/$t")) unless ($dir =~ /CFG|MODLOAD/);
		} elsif ($t !~ /build.pl|modload.pl/) {
			if ($t !~ /README/ and $t !~ /TODO/) {
				if ($t !~ /HOWTO/) {
					push (@res, "$dir/$t");
				}
			}
		}
	}

	return @res;
}
