#!/usr/bin/perl

my $dir = "@ARGV";
$#ARGV = -1;

if ($dir eq "") {
        $dir = `pwd`;
        chomp($dir);
}

$CONFALLOWED = "module protocol command tag docfilter";
foreach $t (split(/ +/, $CONFALLOWED)) {
        #Here we dynamically create the various hashs
        eval "\$$t = {};";
}


if ($dir eq "-") {
	while (<STDIN>) {
		chomp;
		&conf_adder("$_") unless /^\s*$/;
	}
} else {
	opendir (MDC, "$dir/CFG/");
	@modules = readdir(MDC);
	closedir (MDC);
	@modules = grep(!/^\./, @modules);
	#Use a sorted list to allow us to predetermine the loading order.
	foreach $t (sort (@modules)) {
		if ($t ne "") {
			#Now we simply clear the ADDIF stack
			#AddIF blocks canot cross files..
			$#ADDIF = -1;
			open (MDC, "$dir/CFG/$t");
			@tmp_gh = <MDC>;
			close (MDC);
			foreach $in (@tmp_gh) {
				if ($in =~ /^add/i or $in =~ /^loadmodule/i) {
					chomp($in);
					&conf_adder("$in") unless $in =~ /^\s*$/;
				}
			}
		}
	}
}

&mydump;

exit 0;
sub debuglog {
#	print STDERR @_, "\n";
}

sub conf_adder {
	#This handles the conf add directive add
	my $in = shift;
	my $flags = "";
	my $test = "";
	my $to = "";
	my $from = "";
	my $rest = "";
	my $category = "";
	$in =~ s/\s+$//g;
	$in =~ s/^\s+//g;
	my ($opt, $data) = split(/[ =]+/, "$in", 2);
	my $preload = 0;
	my $alt = 0;
	my $pri = 0;
	my $skip = 0;
	#Remove the add prefix
	$opt =~ s/^add//i;
	$opt =~ s/^\s+//g;
	#Handle some definitions
	&debuglog("conf_adder: Got $opt $in");
	if ($#ADDIF > -1) {
		&debuglog("conf_adder: ADDIF Level: $#ADDIF, STATE $ADDIF[$#ADDIF]");
	}
	if ($opt eq "") {
		#Nothing maybe be it's separate
		($opt, $data) = split(/[ =]+/, "$data", 2);
	}
	if ($opt =~ /^if$/i) {
		#WE got an AddIf start
		#Maybe we should use an eval
		my $res = eval $data;
		if ($res > 0) {
			#True
			push (@ADDIF, 0);
		} else {
			#False
			push (@ADDIF, 1);
		}
		return;
	}
	if ($opt =~ /^else$/i) {
		#WE got an Addelse start
		#Flip the state
		return unless $#ADDIF > -1;
		if ($ADDIF[$#ADDIF] > 0) {
			$ADDIF[$#ADDIF] = 0;
		} else {
			$ADDIF[$#ADDIF] = 1;
		}
		return;
	}
	if ($opt =~ /^elseif$/i or $opt =~ /^elsif$/i) {
		#WE got an Addelse start
		return unless $#ADDIF > -1;
		if ($ADDIF[$#ADDIF] < 1) {
			#End any parsing in progress
			$ADDIF[$#ADDIF] = 1;
		} elsif ($data) {
			#Okay we parse this block
			$ADDIF[$#ADDIF] = 0;
		}
		return;
	}
	if ($opt =~ /^endif$/i) {
		#WE got an AddEndIF close
		my $dum = pop(@ADDIF);
		return;
	}
	#test to see if we are to skip
	if ($#ADDIF > -1) {
		if ($ADDIF[$#ADDIF] > 0) {
			return;
		}
	}
	if ($opt =~ /^loadmodule/i) {
		&debuglog("conf_adder: Loading $data");
		$data =~ s/^\s+//g;
		$module->{$data}->{preload} = 1;
		return;
	}
	if ($opt =~ /^load/i) {
		$flags = "$flags load";
		$opt =~ s/load//i;
	}
	if ($opt =~ /^pre/i) {
		$flags = "pre";
		$opt =~ s/pre//i;
	}
	if ($opt =~ /^post/i) {
		$flags = "$flags post";
		$opt =~ s/post//i;
	}
	if ($opt =~ /^dyn/i) {
		$flags = "$flags dynamic";
		$opt =~ s/dyn//i;
	}
	if ($opt =~ /^alt/i) {
		$alt = 1;
		$opt =~ s/alt//i;
	}
	if ($opt =~ /^pri/i) {
		$pri = 1;
		$opt =~ s/pri//i;
	}
	$opt =~ s/^\s+//g;
	#Now we split the remainder of the line
	$category = (split(/ +/, "$data", 2))[0];
	#Now we test if we have a valid and allowed category, lower case only
	$category = lc($category);
	if (defined $category and $category ne "") {
		#Remove any tailing s signs
		$category =~ s/s$//gi;
		if (index(" $CONFALLOWED ", " $category ") > -1) {
			#Okay accepted.
			$data = (split(/ +/, $data, 2))[1];
		} else {
			#Use default of module
			#Assume the user did not define this
			$category = "module";
		}
        } else {
		#Should we assume or try to find it
		$category = "module";
	}
	
	($to, $from, $rest) = split(/ +/, $data, 3);
	&debuglog("conf_adder: Will modify $category $to and field: $opt");

	$category = eval "\$$category";
	
	#Now we handle the main block
	#For lugins we need to do a test here for pre and post and co..
	if (defined $rest) {
		if ($rest =~ /^load /i) {
			$flags = "$flags load";
			$rest =~ s/load\s*//i;
		} 
		if ($rest =~ /^run\Sonce/i or $rest =~ /^runonce/i) {
			$flags = "$flags runonce";
			$rest =~ s/run\Sonce\s*//i;
			$rest =~ s/runonce\s*//i;
		} 
		if ($rest =~ /^pre /i) {
			$flags = "$flags pre";
			$rest =~ s/pre\s*//i;
		} 
		if ($rest =~ /^post /i) {
			$flags = "$flags post";
			$rest =~ s/post\s*//i;
		}
		if ($rest =~ /^dyn /i) {
			$flags = "$flags dynamic";
			$rest = (split(/ +/, $rest, 2))[1];
		}
		if ($rest =~ /^alt /i) {
			$alt = 1;
			$rest =~ s/alt\s*//i;
		}
		if ($rest =~ /^pri /i) {
			$pri = 1;
			$rest =~ s/pri\s*//i;
		}
	}
	#here we test that $rest begins with  test
	if (defined $rest and $rest !~ /^test /i) {
		#If not add it to the from..
		$from = "$from $rest";
		$rest = "";
	}
	#Now try to break the dependency 
	if (defined $from and index($from , "/modules/") > -1) {
		#We simply save it as a relative path
		$from = (split('/modules/', $from))[1];
	}
	if ($alt > 0) {
		#Add an alternate handler or helper
		my $key = "althandler";
		if ($opt =~ /helper/i) {
			$key = "althelper";
		}
		##$from =~ s/ //g;
		if ($from ne "") {
			$category->{$to}->{$key} = "$from";
		}
		#Should we return here?
	} elsif ($opt =~ /^helper/i) {
		#Handler for add helper
		$category->{$to}->{helper} = "$from"; 
	} elsif ($opt =~ /^plugin/i) {
		#Handler for plugins
		if (defined $flags and $flags =~ /pre/) {
			if (! defined $category->{$to}->{pre}) {
				push(@{$category->{$to}->{pre}}, "$from");
			} else {
				push(@{$category->{$to}->{pre}}, "$from") unless index(" @{$category->{$to}->{pre}} ", " $from ") > -1;
			}
		} else {
			if (! defined $category->{$to}->{post}) {
				 push(@{$category->{$to}->{post}}, "$from");
			} else {
				push(@{$category->{$to}->{post}}, "$from") unless index(" @{$category->{$to}->{post}} ", " $from ") > -1;
			}
		}
		#Such subroutines must be dynamic
		$category->{$to}->{static} = 0;
	} elsif ($opt =~ /^alias/i) {
		$category->{$to}->{handler} = "$from";
		$category->{$to}->{alias} = 1;
	} elsif ($opt =~ /^handler/i) {
		if ($from =~ /^\s*\&/ or $from =~ /^\s*([^\(\s]+)\((.+)\)/) {
			#We assume that it is a sub
			$category->{$to}->{handler} = "$from";
		} elsif (index("$from", "/") > -1 or index($from, " ") > -1 or index("$from", "|") > -1) {
			#a file or path or a PIPE
			$category->{$to}->{file} = "$from";
			$category->{$to}->{pos} = 0;
		} else {
			#We assume that it is a sub
			$category->{$to}->{handler} = "$from";
		}
	} elsif ($opt =~ /^test/i) {
		#Add to 
		if ($from =~ /^result$/i) {
			#Okay see if we have undef
			if ($rest =~/^undef$/i) {
				$category->{$to}->{sendundef} = 2;
			} elsif ($rest =~/^null$/i) {
				$category->{$to}->{sendundef} = 1;
			} else {
				$category->{$to}->{senddata} = "$rest";
			}
			$rest = "";
		} else {
			$rest = "$from $rest";
			$from = "";
			#prepend a test, if it is not included.
			if ($rest !~ /^test /i) {
				$rest = "test $rest";
			}
		}
	} elsif ($opt =~ /^option/i) {
		#We accept only load, dyn or static
		if ($from =~ /load/i) {
			$flags = "$flags load";
		}
		if ($from =~ /dyn/i) {
			$flags = "$flags dynamic";
		}
		if ($from =~ /static/i) {
			#Okay we force it to one.
			$category->{$to}->{static} = 1;
		}
		if ($from =~ /^run\Sonce/i or $from =~ /^runonce/i) {
			$flags = "$flags runonce";
		} 
		if ($from =~ /^test/i) {
			if ($rest eq "") {
				$rest = "$from";
			} else {
				$rest = "$from $rest";
			}
			$from = "";
		}
	}
	#Handle the dynamic flag
	if ($flags =~ /dynamic/i) {
		$category->{$to}->{static} = 0;
	} elsif (! defined $category->{$to}->{static}) {
		#Only if it does not exist already
		$category->{$to}->{static} = 1;
	}
	#Handle the Run Once flag
	if ($flags =~ /runonce/i) {
		$category->{$to}->{runonce} = 1;
	}
	#Handle the the tests
	if (defined $rest and $rest ne "") {
		if ($rest =~ /^test\s+result\s/i) {
			$rest =~ s/^test\s+result\s//i;
			$rest =~ s/^\ //g;
			#Okay see if we have undef
			if ($rest =~/^undef$/i) {
				$category->{$to}->{sendundef} = 2;
			} elsif ($rest =~/^null$/i) {
				$category->{$to}->{sendundef} = 1;
			} else {
				$category->{$to}->{senddata} = "$rest";
			}
			$rest = "";
		} elsif ($rest =~ /^test /i) {
			my $one = "";
			foreach $one (split(/\s*test\s\s*/i, $rest)) {
				##push (@{$category->{$to}->{test}}, "$one");
				if ($one eq "" or $one =~ /^\s*$/) {
					next;
				}
				if (index ($one, "\&") > -1 and $#{$category->{$to}->{test}} > -1) {
					unshift (@{$category->{$to}->{test}}, "$one");
					&debuglog("conf_adder: pre-pending test routine $one to $to");
				} else {
					push (@{$category->{$to}->{test}}, "$one");
					&debuglog("conf_adder: appending test routine $one to $to");
				}
			}
			$category->{$to}->{static} = 0;
		}
	}
	#Undefine the sub if it exists
	$category->{$to}->{preload} = 0 unless defined $category->{$to}->{preload};
	if (! defined $category->{$to}->{isextramod}) {
		$category->{$to}->{isextramod} = 0;
		$category->{$to}->{isextramod} = 1 if ($dir eq "-");
	}
	if ($flags =~ /load/i) {
		#Asked to pre load it
		$category->{$to}->{preload} = 1;
	}
}

sub clear_modload_dir {
	my $dir = shift;
	if (-d "$dir") {
		opendir(MDC, "$dir");
		my @modules = readdir(MDC);
		closedir (MDC);
		my $t = "";
		foreach $t (@modules) {
			next if ($t =~ /^\./);
			unlink "$dir/$t" if (! -d "$dir/$t");
		}
	}

}

sub mydump {
	#Sends the data to a FILE or to STDOUT
	my $file = "";	
	foreach $t (split(/ +/, $CONFALLOWED)) {
		#Here we dynamically create the various hashs
		$category = eval "\$$t";
		&clear_modload_dir ("$dir/MODLOAD/$t/");	
		&clear_modload_dir ("$dir/MODLOAD/$t/PRELOAD/");	
		foreach $key (keys %$category) {
			#If $dir ne "-"
			if ($dir eq "-" or ! -d "$dir/MODLOAD/$t") {
				print &statevar("$t:$key", $category->{$key}), "\n";
				next;
			}
			$file = "$dir/MODLOAD/$t/$key";	
			open (MYOUT, "> $file");
			print MYOUT &statevar("$t:$key", $category->{$key}), "\n";
			close (MYOUT);
			#We should make a symbolic link for a preload
			if ($category->{$key}->{preload} > 0) {
				symlink "../$key", "$dir/MODLOAD/$t/PRELOAD/$key";
			}
		}
	}
}

sub statevar {
	#Simply returns a text representation of a variable
	my $prefix = shift;
	my $var = shift;
	
	my $res = "$var";
	
	if ($res =~ /HASH\(0x\w+\)/) {
		return &statehash("$prefix", $var);
	} elsif ($res =~ /ARRAY\(0x\w+\)/) {
		#We simple add a surfix to say it is an array
		my $cnt = -1;
		my $res = "";
		while ($cnt < $#{$var}) {
			$cnt++;
			$res .= "$prefix:\($cnt\): @{$var}[$cnt]\n";
		}
		$res =~ s/\n$//gs;
		return "$res";
	} else {
		return "$prefix: $var";
	}
}

sub statehash {
	#Dumps a hash
	my ($prefix, $var, $key, $res);
	$prefix = shift;
	$var = shift;
	$res = "";
	foreach $key (keys %$var) {
		if ($res eq "") {
			$res = &statevar("$prefix:$key", $var->{$key});
		} else {
			$res = join("\n", $res, &statevar("$prefix:$key", $var->{$key}));
		}
	}
	return "$res";
}

